--- Edge Of Reality

local function SonicModelExists()
    if SonicSD and file.Exists("models/weapons/c_sonicsd.mdl", "GAME") then
        return true
    end
    return false
end

local T = {}

T.Versions = {
    randomize = false,
    allow_custom = true,
    randomize_custom = false,

    main = {
        id = "edgeoftimepolicebox",
    },
    other = {
		{
			name = "'Destroyed' Interior",
            id = "edgeoftimevoid",
		},
	}
}

T.Base = "base"
T.Name = "The Edge Of Time Police Box"
T.ID = "edgeoftimepolicebox"
T.Interior = {
    Model = "models/FuzzyLeo/EdgeOfReality/interiorvoid.mdl",
    IdleSound = false,
    ScreensEnabled = false,
    Light = {
        color = Color(255, 255, 255),
        warncolor = Color(255, 15, 15),
        pos = Vector(0, 0, 85),
        brightness = 0.2,
        nopower = false
    },
    Portal = {
        -- Generated by portals debug tool
        pos = Vector(26.7, 0, 48),
        ang = Angle(-0, 180, 0),
        width = 56,
        height = 100,
        thickness = -3,
    },
    Fallback = {
        pos = Vector(0, 0, 10),
        ang = Angle(0, 230, 0)
    },
    Screens = {
        {
            pos = Vector(-7.8, -24.7, 54),
            ang = Angle(0, 0, 90),
            width = 256,
            height = 205.5,
            gui_rows = 2,
            power_off_black = true
        }
    },
    ExitDistance = 1000,
    Sounds={
        FlightLoop = "FuzzyLeo/EdgeOfReality/BBC_TARDIS_Flying_Loop.wav",
        Door={
			enabled=true,
			open="FuzzyLeo/EdgeOfReality/CoolyDude/eot_door_open.mp3",
			close="FuzzyLeo/EdgeOfReality/CoolyDude/eot_door_close_3.mp3",
            locked = "FuzzyLeo/EdgeOfReality/EORDoorLock.mp3"
		},
	},
    Sequences = "kleiner_sequence",
    Parts = {
		door = {
            Model="models/FuzzyLeo/EdgeOfReality/ExteriorJodieDoors.mdl",
            posoffset=Vector(26.7, 0, -48),
        },
        eorexterior_interiorbox            =   {},
    },
    Controls = {
        eorexterior_interiorbox              = "thirdperson_careful",
        eorexterior_interiorbox2              = "thirdperson_careful",
    },
    IntDoorAnimationTime = 0.4,
    Tips = {},
    -- Interior.Tips are deprecated; should be deleted when the extensions update and
    -- replace with Interior.CustomTips, Interior.PartTips and Interior.TipSettings
    TipSettings = {
        view_range_min = 70,
        view_range_max = 90,
    },
    CustomTips = {
        --{ text = "Example", pos = Vector(0, 0, 0) },
    },
    PartTips = {

    },
    LightOverride = {
        basebrightness = 0.0025 ,
        nopowerbrightness = 0
    },

    BreakdownEffectPos = Vector(0, 0, 40),
}

T.Interior.TextureSets = {
	["normal"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/",

                --Door Power
		        { "door", 0, "tardis" },
                { "door", 3, "tardis_white" },
				{ "door", 5, "tardis_alt1" },
				{ "door", 6, "tardis_alt2" },
				{ "door", 7, "tardis_alt3" },
				{ "door", 8, "tardis_alt4" },

                --Door Frame Power
                { "eorexterior_interiorbox", 0, "tardis" },
                { "eorexterior_interiorbox", 2, "tardis_white" },
                { "eorexterior_interiorbox", 4, "tardis_alt1" },
				{ "eorexterior_interiorbox", 5, "tardis_alt2" },
				{ "eorexterior_interiorbox", 6, "tardis_alt3" },
				{ "eorexterior_interiorbox", 7, "tardis_alt4" },

                { "eorexterior_interiorbox2", 0, "tardis" },
                { "eorexterior_interiorbox2", 2, "tardis_white" },
                { "eorexterior_interiorbox2", 4, "tardis_alt1" },
				{ "eorexterior_interiorbox2", 5, "tardis_alt2" },
				{ "eorexterior_interiorbox2", 6, "tardis_alt3" },
				{ "eorexterior_interiorbox2", 7, "tardis_alt4" },

			},
    ["flight"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/",
        base = "normal",
	},
    ["warning_flight"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/warning/",
        base = "normal",
	},
    ["poweroff"] = {
                prefix = "models/FuzzyLeo/EdgeOfRealityJodie/off/",
                base = "normal",
    },
	["warning"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/warning/",
        base = "normal",
	},
}


T.CustomHooks = {
	travel_textures = {
        exthooks = {
            ["PostInitialize"] = true,
            ["PowerToggled"] = true,
            ["HealthWarningToggled"] = true,
            ["DematStart"] = true,
            ["MatStart"] = true,
            ["PreMatStart"] = true,
            ["StopDemat"] = true,
            ["StopMat"] = true,
            ["InterruptTeleport"] = true,
        },
        func = function(ext, int, data_id, data_value)
			local flight = ext:GetData("flight")
			local teleport = ext:GetData("teleport")
			local vortex = ext:GetData("vortex")
			local power = ext:GetData("power-state")
			local warning = ext:GetData("health-warning", false)
			local active = flight or teleport or vortex

			local selected = "normal"

			if not power then
				selected = "poweroff"
			elseif warning and active then
				selected = "warning_flight"
			elseif warning then
				selected = "warning"
			elseif active then
				selected = "flight"
			end

			int:ApplyTextureSet(selected)
            ext:ApplyTextureSet(selected)
		end
	},
    door_bodygroup_sync_ext = {
        exthooks = { ["PartBodygroupChanged"] = true, },
        inthooks = { ["PartBodygroupChanged"] = true, },
        func = function(ext,int,part,bodygroup,value)
            if not IsValid(int) then return end
            if not IsValid(part) or part.ID ~= "door" then return end

            local door_int = int:GetPart("door")
            local door_ext = ext:GetPart("door")

            if not IsValid(door_int) or not IsValid(door_ext) then return end

            if part.ExteriorPart and door_int:GetBodygroup(bodygroup) ~= value then
                door_int:SetBodygroup(bodygroup, value)
            end

            if part.InteriorPart and door_ext:GetBodygroup(bodygroup) ~= value then
                door_ext:SetBodygroup(bodygroup, value)
            end

        end,
    },
}


T.CustomSettings = {

}

T.Templates = {

    --Exterior
    edgeoftime_box = { override = true, },

}

TARDIS:AddInterior(T)
